<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Instruction Nodes</TITLE>
<link href="suif1_15.html" rel=Next>
<link href="suif1_13.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_13.html">previous</A>, <A HREF="suif1_15.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC14" HREF="suif1_toc.html#TOC14">Instruction Nodes</A></H3>
<P>
<A NAME="IDX44"></A>
<A NAME="IDX45"></A>
<A NAME="IDX46"></A>

</P>
<P>
<A NAME="IDX47"></A>
<A NAME="IDX48"></A>
<A NAME="IDX49"></A>
<A NAME="IDX50"></A>
Instruction nodes, implemented by the <CODE>tree_instr</CODE> class, are the
leaves of the abstract syntax trees.  Each instruction node contains a
single instruction or expression tree which can be accessed using the
<CODE>instr</CODE> method.  The <CODE>set_instr</CODE> method attaches an
instruction to a <CODE>tree_instr</CODE>, and the <CODE>remove_instr</CODE> method
detaches an instruction.  Note that <CODE>remove_instr</CODE> does not free
the storage for the instruction, and unlike the <CODE>remove</CODE> method in
the <CODE>instruction</CODE> class (see section <A HREF="suif1_28.html#SEC28">Source Operands</A>), it does not
remove the instruction from its expression tree.  Conversely, removing
an instruction from an expression tree with the <CODE>remove</CODE> method
will automatically call <CODE>remove_instr</CODE> if necessary.

</P>
<P>
The SUIF library automatically maintains back-pointers from instructions
to their parent <CODE>tree_instr</CODE> nodes.  As a result, the
<CODE>set_instr</CODE> and <CODE>remove_instr</CODE> methods must always be used to
attach and detach instructions to <CODE>tree_instr</CODE> nodes.  Never use
the instruction in a <CODE>tree_instr</CODE> elsewhere without first calling
<CODE>remove_instr</CODE>, and never use <CODE>set_instr</CODE> with a
<CODE>tree_instr</CODE> that already contains an instruction.

</P>
<P>
Unlike other tree nodes, instruction nodes are considered temporary
objects.  They are destroyed and created automatically by the SUIF
library when switching between expression trees and flat lists, and
their annotations and ID numbers are not written to the output files.
Consequently, annotations should generally not be attached to them but
should instead be placed directly on the instructions.

</P>
<P>
The destructor for the <CODE>tree_instr</CODE> class also deletes the
instruction or expression tree contained in the node.  This is the
desired behavior for most cases.  However, if you only want to delete
the <CODE>tree_instr</CODE> node, simply call <CODE>remove_instr</CODE> first and
save a pointer to the instruction.

</P>
<P>
<A NAME="IDX51"></A>
<A NAME="IDX52"></A>
Often in SUIF one needs to perform some operation on all the
instructions in a procedure.  The <CODE>map</CODE> methods in the
<CODE>tree_node</CODE> and <CODE>tree_node_list</CODE> classes (see section <A HREF="suif1_21.html#SEC21">Mapping Functions Over Subtrees</A>) make it easy to visit all of the instruction nodes.  Once an
instruction node is reached, its <CODE>instr_map</CODE> method may be used to
apply a function to every instruction in the associated expression tree.
Given a function of type <CODE>instr_map_f</CODE>, <CODE>instr_map</CODE> will
traverse the expression tree and apply the function to every
instruction.  The <CODE>preorder</CODE> parameter is used to select either
preorder or postorder traversals; the default is preorder.  The
<CODE>instr_map_f</CODE> function takes two arguments: the instruction pointer
and a <CODE>void*</CODE> value that you provide to <CODE>instr_map</CODE>.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_13.html">previous</A>, <A HREF="suif1_15.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
